import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

/*
 * GUI (Graphical User Interface), mit einem eigenen Layout
 */
public class Haupt implements ActionListener{
    JButton[] tttbut;
    JButton but1;
    JLabel lab1;
    JFrame frame;

    Spielfeld sf;

    /**
     * Hauptmethode: Mit dieser Methode wird das
     * Programm gestartet.
     */
    public static void main() {
        Haupt sk = new Haupt();
        sk.sf = new Spielfeld();
        sk.zeigeFenster();
    }

    /**
     * Diese Methode wird einmal zu Beginn des Programms
     * ausgeführt (aufgerufen aus der main-Methode).
     * Hier wird die Benutzeroberfläche erzeugt.
     */
    public void zeigeFenster() {
        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("Null Layout");
        frame.setLayout(null); 

        but1 = new JButton("Reset");
        but1.setBounds(10,10,200,30);
        but1.addActionListener(this);
        frame.add( but1 );

        lab1 = new JLabel("Informatik macht Spaß.");
        lab1.setBounds(10,40,190,30);
        frame.add(lab1);

        // Hier wird nun ein Array von 9 JButton-Objekten angelegt.
        tttbut = new JButton[9];
        // TODO: hier müssen nun die 9 TicTacToeButtons angelegt werden
        // das kann man - wenn man geschickt ist - auch
        // mit Schleifen etwas vereinfachen.
        tttbut[0] = new JButton();
        tttbut[0].setBounds(100,100,30,30);
        tttbut[0].addActionListener(this);
        frame.add(tttbut[0]);

        tttbut[1] = new JButton();
        tttbut[1].setBounds(150,100,30,30);
        tttbut[1].addActionListener(this);
        frame.add(tttbut[1]);

        tttbut[2] = new JButton();
        tttbut[2].setBounds(200,100,30,30);
        tttbut[2].addActionListener(this);
        frame.add(tttbut[2]);

        tttbut[3] = new JButton();
        tttbut[3].setBounds(110,140,30,30);
        tttbut[3].addActionListener(this);
        frame.add(tttbut[3]);

        tttbut[4] = new JButton();
        tttbut[4].setBounds(170,140,30,30);
        tttbut[4].addActionListener(this);
        frame.add(tttbut[4]);

        tttbut[5] = new JButton();
        tttbut[5].setBounds(190,140,30,30);
        tttbut[5].addActionListener(this);
        frame.add(tttbut[5]);

        tttbut[6] = new JButton();
        tttbut[6].setBounds(100,160,30,30);
        tttbut[6].addActionListener(this);
        frame.add(tttbut[6]);

        tttbut[7] = new JButton();
        tttbut[7].setBounds(120,160,30,30);
        tttbut[7].addActionListener(this);
        frame.add(tttbut[7]);

        tttbut[8] = new JButton();
        tttbut[8].setBounds(160,170,30,30);
        tttbut[8].addActionListener(this);
        frame.add(tttbut[8]);

        frame.pack();
        frame.setSize(430,350);
        frame.setResizable(false);
        frame.setVisible( true );

        updateGUI();
    }

    /**
     * Diese Methode wird aufgerufen, wenn irgendein Button geklickt wird.
     * Der Button but1 entspricht dem "Reset"-Button.
     * Ansonsten sind die Buttons aus dem Spielfeld gedrückt worden.
     */
    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == but1) {
            sf = new Spielfeld(); // Neues Spielfeld-Objekt erzeugen
                                  // (Das alte wird "vergessen")
            for(int i = 0; i < 9; i++) {
                tttbut[i].setEnabled(true); // Jeden Button wieder aktivieren
            }            
        }

        // hier wird nun für jeden Button im Array überprüft,
        // ob er der Auslöser dieser Methode war. Wenn ja, 
        // müssen wir das Spielfeld-Objekt davon informieren
        for(int i = 0; i < 9; i++) {
            if(e.getSource() == tttbut[i]) {
                sf.setPlayerAtAndProceed(i);
            }
        }

        updateGUI();
    }

    /**
     * Methode, die dafür sorgt, dass die Benutzeroberfläche immer
     * aktuell ist. D.h. alle TicTacToe-Buttons des Spielfelds
     * werden abgefragt, welche Spielerin das Feld belegt.
     * Dementsprechend werden die Bilder gesetzt.
     */
    public void updateGUI() {
        // Update Buttons and Labels
        lab1.setText("Player "+sf.getPlayerAtTurn()+" ist dran!");
        for(int i = 0; i < 9; i++) {
            int player = sf.getPlayerAt(i); // SpielerNr auf Feld Nr. i
            if(player == 1) {
                tttbut[i].setIcon(new ImageIcon("./icon1.png"));            
            } else if(player == 2) {
                tttbut[i].setIcon(new ImageIcon("./icon2.png"));            
            } else {
                tttbut[i].setIcon(new ImageIcon("./icon0.png"));            
            }
        }

        // Möglichen Gewinner ermitteln
        int winner = sf.detectWinner();
        if(winner != 0) {
            lab1.setText("Player "+winner+" ist Gewinner!");
            // Falls es einen Gewinner gibt, so sollen alle
            // Buttons inaktiv werden:
            for(int i = 0; i < 9; i++) {
                tttbut[i].setEnabled(false);
            }

        }
        
        // Sorgt dafür, dass der Fensterinhalt durch 
        // das Betriebssystem neu gezeichnet wird:
        frame.repaint();
    }

}



