import java.util.Arrays;

/**
 * Die Klasse Spielfeld repräsentiert ein TicTacToe-Spielfeld.
 * Jedes Spielfeld hat eine Kennziffer nach folgendem Schema:
 * 0 1 2
 * 3 4 5
 * 6 7 8
 * 
 * Für jedes Feld kann abgefragt werden, wie der Status ist
 * wobei gilt:
 * Status 0: unbesetzt,
 * Status 1: von Spieler 1 belegt
 * Status 2: von Spieler 2 belegt
 * 
 * Das Spielfeld kennt außerdem die Nummer jener Spielerin
 * die gerade am Zug ist. (Eigenschaft "playerAtTurn")
 */
public class Spielfeld {
    private int[] grid; 
    // Zählung beim Raster:
    // 012
    // 345
    // 678
    private int playerAtTurn;

    /**
     * Legt ein neues Spielfeld an und setzt den Spieler,
     * der am Zug ist, auf Spieler Nr. 1
     */
    public Spielfeld() {
        grid = new int[9];
        for(int i = 0; i < 9; i++) {
            grid[i] = 0;
        }
        playerAtTurn = 1;
    }

    /**
     * liefert die Nr. des Spielers, welcher gerade am Zug ist.
     */
    public int getPlayerAtTurn() {
        return -1; // TODO: Dieser Wert ist natürlich falsch
    }

    /**
     * liefert die Nr. des Spielers, welcher das angegebene Feld
     * besetzt hat. Steht kein Spieler auf dem Feld, so wird
     * eine Null zurückgegeben.
     */
    public int getPlayerAt(int idx) {
        return grid[idx];
    }

    /**
     * Markiert das angegebene Feld mit der Nr. des Spielers,
     * der es nun belegt. Es muss also nur das betreffende
     * Array-Element verändert werden.
     * Außerdem kommt nun der andere Spieler an die Reihe.
     * 
     * Vorsicht: ist das Feld schon belegt (d.h. der Wert ist != 0)
     * so passiert gar nichts!
     */
    public void setPlayerAtAndProceed(int idx) {
        // die nächsten Zeilen sind Unsinn. Sie sollen nur
        // das "grid" verändern, so dass man in diesem halbfertigen
        // Programm auch etwas sieht.
        grid[(int)(Math.random()*9)] = (int)(Math.random()*3);
        System.out.println("Button "+idx+" gedrueckt.");
        System.out.println(Arrays.toString(grid));
        // TODO
    }

    /**
     * Private Hilfsfunktion. Wenn alle drei Felder den gleichen
     * Wert haben, so wird jener Wert zurückgegeben (Also die
     * Nummer jener Spielerin, die alle drei Felder belegt). Falls
     * die Werte nicht identisch sind, so wird null zurückgegeben.
     * Diese Funktion lässt sich gut in detectWinner benutzen.
     */
    private int detectTriple(int a, int b, int c) {
        int result = 0;
        // Falls Wert im FeldNr a und b und c identisch sind....
        if((grid[a] == grid[b]) && (grid[b] == grid[c])) {
            result = grid[a];
        }
        return result;
    }

    /**
     * Liefert die Nr. des Spielers zurück, der einen 3er hat.
     * Falls niemand gewonnen hat, wird die Zahl 0 zurückgegeben.
     */
    public int detectWinner() {
        return 0; // TODO
    }

}
